/*
  _===_ _           _                  ______ _     _             _ _ _
 |  ___| |         | |                 | ___ (_)   | |           (_) | |
 | |__ | | ___  ___| |_ _ __ ___ ______| |_/ /_  __| | ___  _   _ _| | | ___ _   _ _ __
 |  __|| |/ _ \/ __| __| '__/ _ \______| ___ \ |/ _` |/ _ \| | | | | | |/ _ \ | | | '__|
 | |___| |  __/ (__| |_| | | (_) |     | |_/ / | (_| | (_) | |_| | | | |  __/ |_| | |
 \____/|_|\___|\___|\__|_|  \___/      \____/|_|\__,_|\___/ \__,_|_|_|_|\___|\__,_|_|

 Essai de chenillard simple sur l'affichage de la plateforme Z80 PRO-83.
 Code source développé et compilé sur SDCC
 Électro-Bidouilleur, V1, Juillet 2022. https://www.youtube.com/Électro-Bidouilleur
 Licence de droits: Attribution 4.0 International (CC BY 4.0)  Lisez https://creativecommons.org/licenses/by/4.0/deed.fr  
*/

__sfr __at 0x48 chiffr_sel;                   // Définition des registres spéciaux de l'affichage
__sfr __at 0x4C segm_sel;                     //           "


// Variables Globales
__at 0x1000 volatile unsigned char cnth;      // Partie haute du compteur de pause
__at 0x1001 volatile unsigned char cntl;      // Partie basse du compteur de pause
__at 0x1002 volatile unsigned char bit_pos;   // Masque de position identifiant quel affichage allumer

// Fonction principale
void main() 
{   
   while(1)                                   // Boucle principale
   {
      for (bit_pos = 1; bit_pos > 0; bit_pos = bit_pos * 2)       // Parcours des positions d'affichage
      {   
         segm_sel = 0xDC;                     // Création d'un petit carré dans le bas de l'affichage
         chiffr_sel = ~bit_pos;               // Sélection de l'affichage (logique inversée)
         pause();                             // Pause pour les yeux...
      }
   }
}

// Fonction générant une pause
void pause()
{  
   for (cnth = 10; cnth > 0; cnth--)          // Boucle haute du compteur
   {
      for (cntl = 255; cntl > 0; cntl--);     // Boucle basse du compteur
   }   
}

// Fin
